import 'package:aitrainer_app/viewmodel/exercise_type_changing_view_model.dart';
import 'package:aitrainer_app/viewmodel/exercise_type_view_model.dart';
import 'package:aitrainer_app/widgets/exercise_type_list_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'package:aitrainer_app/widgets/nav_drawer.dart';

class ExerciseTypeListPage extends StatefulWidget{
  _ExerciseTypeListPageState createState() => _ExerciseTypeListPageState();
}

class _ExerciseTypeListPageState extends State {
  Future<List<ExerciseTypeViewModel>> _exerciseTypes;
  final _exerciseTypeViewModel = ExerciseTypeChangingViewModel(null);

  // Push the page and remove everything else
  navigateToPage(BuildContext context, String page) {
    Navigator.of(context).pushNamedAndRemoveUntil(page, (Route<dynamic> route) => false);
  }

  @override
  void initState() {
    super.initState();
    _exerciseTypes = _exerciseTypeViewModel.getExerciseTypes();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      drawer: NavDrawer(),
      appBar: AppBar(
        title: Text('Exercises'),
      ),
      body: Center(
        child: FutureBuilder<List<ExerciseTypeViewModel>>(
          future: _exerciseTypes,
          builder: (context, snapshot) {
            if (snapshot.hasData) {
              return ExerciseTypeListWidget(exerciseTypes: _exerciseTypeViewModel.exerciseTypeList);
            } else if (snapshot.hasError) {
              return Text("${snapshot.error}");
            }

            // By default, show a loading spinner.
            return CircularProgressIndicator();
          },
        ),
      ),
        floatingActionButton: FloatingActionButton(
          onPressed: () => Navigator.pushNamed(
              context,
              'exerciseTypeNewPage',
          ),
          child: Icon(Icons.add,),
          mini: true,
        )
    );
  }
}