import 'package:aitrainer_app/viewmodel/exercise_type_changing_view_model.dart';
import 'package:aitrainer_app/viewmodel/exercise_type_view_model.dart';
import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'package:aitrainer_app/widgets/nav_drawer.dart';

// ignore: must_be_immutable
class ExerciseTypeModifyPage extends StatefulWidget{
  ExerciseTypeViewModel exerciseTypeViewModel;
  ExerciseTypeModifyPage({this.exerciseTypeViewModel});
  _ExerciseTypeModifyPageState createState() => _ExerciseTypeModifyPageState();
}

class _ExerciseTypeModifyPageState extends State<ExerciseTypeModifyPage> {
  final _formKey = GlobalKey<FormState>();

  @override
  Widget build(BuildContext context) {
    final ExerciseTypeViewModel exerciseType = ModalRoute.of(context).settings.arguments;
    ExerciseTypeChangingViewModel changeModel;
    return Scaffold(
      drawer: NavDrawer(),
      appBar: AppBar(
        title: Text('Modify "' + exerciseType.name + '"' ),
      ),
      body: Center(
        child: Form(
                  key:_formKey,
                  child: Column(
                  children: <Widget>[
                    TextFormField(
                      initialValue: exerciseType.name,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        labelText: 'Exercise',
                      ),
                      validator: (input) => input.length == 0 ? "Please type the name of the exercise" : null,
                      onChanged: (input) => exerciseType.setName(input),
                    ) ,
                    TextFormField(
                      initialValue: exerciseType.description,
                      minLines: 4,
                      maxLines: 10,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        labelText: 'Description',
                      ),
                      onChanged: (input) => exerciseType.setDescription(input),
                    )
                  ],
                ),
              ),
        ),
        floatingActionButton: FloatingActionButton(
          onPressed: () => {
          if (_formKey.currentState.validate()) {
            changeModel = ExerciseTypeChangingViewModel(exerciseType),
            changeModel.saveExerciseType(),
            Navigator.pop(context),
          }
          },
          child: Icon(Icons.save,),
          mini: true,
        )
    );
  }
}
