import 'package:aitrainer_app/viewmodel/exercise_type_changing_view_model.dart';
import 'package:aitrainer_app/viewmodel/exercise_type_view_model.dart';
import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'package:aitrainer_app/widgets/nav_drawer.dart';

class ExerciseTypeNewPage extends StatefulWidget{
  _ExerciseTypeNewPageState createState() => _ExerciseTypeNewPageState();
}

class _ExerciseTypeNewPageState extends State {
  final ExerciseTypeViewModel exerciseType = ExerciseTypeViewModel();
  final _formKey = GlobalKey<FormState>();

  @override
  Widget build(BuildContext context) {
    ExerciseTypeChangingViewModel model;
    exerciseType.createNew();
    return Scaffold(
        drawer: NavDrawer(),
        appBar: AppBar(
          title: Text('New exercise'),
        ),
        body: Center(
          child: Form(
            key: _formKey,
            child: Column(
              children: <Widget>[
                TextFormField(
                  decoration: InputDecoration(
                    border: OutlineInputBorder(),
                    labelText: 'Exercise',
                  ),
                  validator: (input) => input.length == 0 ? "Please type the name of the exercise" : null,
                  onChanged: (input) => exerciseType.setName(input),
                ) ,
                TextFormField(
                  minLines: 4,
                  maxLines: 10,
                  decoration: InputDecoration(
                    border: OutlineInputBorder(),
                    labelText: 'Description',
                  ),
                  onChanged: (input) => exerciseType.setDescription(input),
                )
              ],
            ),
          ),
        ),
        floatingActionButton: FloatingActionButton(
          onPressed: () => {
          if (_formKey.currentState.validate()) {
            model = ExerciseTypeChangingViewModel(exerciseType),
            model.addExerciseType(),
            model.addNewExercise(exerciseType),
            Navigator.pop(context),
          }
          },
          child: Icon(Icons.save,),
          mini: true,
        )
    );
  }
}