import 'package:aitrainer_app/model/customer.dart';
import 'package:aitrainer_app/model/exercise.dart';
import 'package:aitrainer_app/model/exercise_type.dart';
import 'package:aitrainer_app/service/exercise_service.dart';
import 'package:flutter/cupertino.dart';

import 'exercise_view_model.dart';

class ExerciseChangingViewModel with ChangeNotifier {
  Customer customer;
  ExerciseType exerciseType;

  ExerciseViewModel exerciseViewModel = ExerciseViewModel();

  ExerciseChangingViewModel(exerciseViewModel) {
    this.exerciseViewModel = exerciseViewModel;
  }

  int quantity;

  setCustomer(Customer customer) {
    this.customer = customer;
  }

  setExerciseType( ExerciseType exerciseType) {
    this.exerciseType = exerciseType;
  }

  setQuantity(int quantity) {
    this.quantity = quantity;
  }

  addExercise() async {
    this.exerciseViewModel = exerciseViewModel;
    final Exercise modelExercise = exerciseViewModel.getExercise();
    modelExercise.customerId = this.customer.customerId;
    modelExercise.exerciseTypeId = this.exerciseType.exerciseTypeId;
    await ExerciseApi().addExercise(modelExercise);
  }

  createNewModel() {
    exerciseViewModel = ExerciseViewModel();
    exerciseViewModel.createNew();
  }

}