import 'package:aitrainer_app/model/exercise_type.dart';
import 'package:aitrainer_app/viewmodel/exercise_type_view_model.dart';
import 'package:flutter/cupertino.dart';
import 'package:aitrainer_app/service/exercisetype_service.dart';

class ExerciseTypeChangingViewModel extends ChangeNotifier {
  ExerciseTypeViewModel exerciseType = ExerciseTypeViewModel();
  List<ExerciseTypeViewModel> exerciseTypeList = List<ExerciseTypeViewModel>();

  ExerciseTypeChangingViewModel(exerciseType) {
    this.exerciseType = exerciseType;
  }

  Future<void> addExerciseType() async {
    this.exerciseType = exerciseType;
    final ExerciseType modelExerciseType = exerciseType.getExerciseType();
    await ExerciseTypeApi().addExerciseType(modelExerciseType);
  }

  Future<void> saveExerciseType() async {
    this.exerciseType = exerciseType;
    final ExerciseType modelExerciseType = exerciseType.getExerciseType();
    await ExerciseTypeApi().saveExerciseType(modelExerciseType);
  }

  Future<List<ExerciseTypeViewModel>> getExerciseTypes() async {
    final results =  await ExerciseTypeApi().getExerciseTypes("");
    this.exerciseTypeList = results.map((item) => ExerciseTypeViewModel( exerciseType: item) ).toList();
    notifyListeners();
    return this.exerciseTypeList;
  }

  addNewExercise(ExerciseTypeViewModel exerciseTypeViewModel) {
    exerciseTypeList.add(exerciseTypeViewModel);
  }
}