import 'package:aitrainer_app/viewmodel/exercise_changing_view_model.dart';
import 'package:aitrainer_app/viewmodel/exercise_type_view_model.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

class ExerciseTypeListWidget extends StatefulWidget {
  final List<ExerciseTypeViewModel> exerciseTypes;
  ExerciseTypeListWidget({this.exerciseTypes});

  @override
  _ExerciseTypeListWidgetState createState() => _ExerciseTypeListWidgetState();
}

class _ExerciseTypeListWidgetState extends State<ExerciseTypeListWidget> {
  //static const routeName = '/exercise_type_list';
  bool visible = false;

  // Push the page and remove everything else
  navigateToPage(BuildContext context, String page) {
    Navigator.of(context).pushNamedAndRemoveUntil(page, (Route<dynamic> route) => false);
  }

  @override
  Widget build(BuildContext context) {

    return ListView.builder(
      itemCount: widget.exerciseTypes.length,
      itemBuilder: (context, index) {

        final exerciseType = widget.exerciseTypes[index];

        return ListTile(
          contentPadding: EdgeInsets.all(10),
          leading: Icon(Icons.directions_run),
          title: Text(exerciseType.name),
          subtitle:
          Container(
              child: Visibility(
                visible: exerciseType.visible,
                child: Column(
                  children: <Widget>[
                    Text(exerciseType.description),
                    new RaisedButton(
                      child: new Text('Modify'),
                      color: Color.fromRGBO(244, 122, 22, 0.9),
                      onPressed: () => {
                          Navigator.pushNamed(
                              context,
                              'exerciseTypeModifyPage',
                              arguments: exerciseType
                          )
                      },
                    ),
                    new RaisedButton(
                      child: new Text('Select'),
                      color: Colors.blueGrey,
                      onPressed: () => {
                        Navigator.pop(context),
                        Provider.of<ExerciseChangingViewModel>(context, listen: false).setExerciseType(exerciseType.exerciseType),
                      },
                    ),
                  ],
                ),
              ),
          ),
          onTap: () { setState( () {
              exerciseType.visible = true;
            });
          },
        );
      },
    );
  }
}
